<?php 

function views_sm_options() {
  return array(
  );
}

function views_sm_arguments() {
  return array(
    'list' => array(
    ),
    'export' => array(
      '- | dir-name' => 'stdout or directory',
      'view-name(s)' => 'view name(s)',
    ),
  );     
}

function views_sm_list() {
  $args=func_get_args();
  $views=views_get_all_views();
  $views = count($args) ? array_intersect_key($views, array_flip($args)) : $views;
  if ($missing=array_diff($args,array_keys($views))) {
    drush_die( 'Unknown view name(s) ' . implode(', ', $missing), 2);
  }
  ksort($views);
  foreach ($views as $name => $view) {
    echo "$name " . ($view->disabled ? 'disabled': 'enabled') . "\n";
  }
}

function views_sm_export() {
  $args=func_get_args();
  $dir=array_shift($args);
  if (count($args)) {
    drush_die( "Too many arguments.");
  }
  $views=views_get_all_views();
  foreach ($views as $name => $view) {
    $code = views_views_exportables('export', array($name  => TRUE), $name);
    if (is_dir($dir)) {
      $file=realpath($dir) . '/views_' . $name . '.txt';
      if (drush_get_context('DRUSH_SIMULATE')) {
        drush_log( "Should write to file $file");
      }
      else {
        drush_log( "Writing file $file");
        file_put_contents( $file, $code);
      }
    }
    else if ($dir=='-') {
      echo "$name\n";
      if (!drush_get_context('DRUSH_SIMULATE')) {
        echo $code;
      }
    }
    else {
        drush_die( "'$dir' is not a directory. Use '-' or an existing directory", 2);
    }
  }
}
